finalteveo/AppTeveo/urls.py
from django.contrib import admin
from django.urls import path, include
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('ayuda/', views.pagina_ayuda, name='ayuda'),
    path('configuracion/', views.configuracion, name='configuracion'),
    path('camaras/', views.camaras, name='camaras'),
    path('camaras/<str:id>/', views.camara, name='camara'),
    path('<str:id>-dyn/', views.camara_dinamica, name='camara_dinamica'),
    path('comentario/<int:id>/', views.comentarios, name='comentarios'),
    path('camara/<int:id>/', views.camara_json, name='camara_json'),
    path('teveo/descargar-fuente-datos/<str:listado>/', views.descargar_fuente_datos, name='descargar_fuente_datos'),
    path('camara/<int:id>/imagen', views.imagen_dinamica, name='imagen_dinamica'),
    path('<int:id>/comentarios_dinamicos/', views.comentarios_dinamicos, name='comentarios_dinamicos'),
]

finalteveo/Teveo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic import RedirectView

urlpatterns = [
    path('', RedirectView.as_view(url='/teveo', permanent=True)),
    path('admin/', admin.site.urls),
    path('teveo/', include('AppTeveo.urls')),
]

finalteveo/AppTeveo/models.py
from django.db import models
import random
import string

# Create your models here.

class Camara(models.Model):
    nombre = models.CharField(max_length=100)
    descripcion = models.TextField()
    url = models.URLField()
    lugar = models.CharField(max_length=250)
    latitud = models.FloatField()
    longitud = models.FloatField()

class Comentario(models.Model):
    nombre = models.CharField(max_length=100)
    camara = models.ForeignKey(Camara, on_delete=models.CASCADE)
    contenido = models.TextField()
    fecha = models. DateTimeField(auto_now_add=True)
    img_src = models.CharField(max_length=200)


class Usuario(models.Model):
    userName = models.CharField(max_length=100, default='Anónimo')
    sizeSelect = models.CharField(max_length=10)
    fontSelect = models.CharField(max_length=50)
    sesion_id = models.CharField(max_length=200,default='abcdefghyjklmñopkrst')


class Like(models.Model):
    Camara = models.ForeignKey(Camara, on_delete=models.CASCADE)
    Usuario = models.ForeignKey(Usuario, on_delete=models.CASCADE)
    
    def __str__(self):
        return f"Like del usuario {self.Usuario.userName} a la cámara {self.Camara.nombre}"

finalteveo/AppTeveo/views.py
import os
import datetime
import base64
import requests
import random
import string
from .models import Comentario, Camara, Usuario, Like
from django.shortcuts import render,redirect, get_object_or_404
from django.core.paginator import Paginator
from django.http import JsonResponse, HttpResponse, HttpResponseRedirect
import xml.etree.ElementTree as ET
from django.conf import settings
from django.db.models import Count
from django.urls import reverse


def contador():
    #cuenta las camaras y los comentarios que hay
    numero_camaras = Camara.objects.count()
    numero_comentarios = Comentario.objects.count()
    return numero_camaras, numero_comentarios


def pagina_ayuda(request):

    session_key = request.session.session_key
    configUsuario = Usuario.objects.filter(sesion_id=session_key).first()
    if not configUsuario:
        configUsuario = configUsuario(userName='Anónimo')

    numero_camaras, numero_comentarios = contador()

    context = {
        'numero_camaras' : numero_camaras,
        'numero_comentarios' : numero_comentarios,
        'configUsuario' : configUsuario,
    }
    return render(request, 'AppTeveo/pagina_ayuda.html', context)


def index(request):

    # Crear una sesión si no existe
    if not request.session.session_key:
        request.session.create()

    # Verificar si ya existe un usuario anónimo  en la base de datos
    usuario_anonimo = Usuario.objects.filter(userName='Anónimo').first()
    if not usuario_anonimo:
        usuario_anonimo= Usuario.objects.create(
            userName='Anónimo',
            sesion_id= 'abcdefghyjklmñopkrst',
            sizeSelect='medium',
            fontSelect='Arial'
        )

    # Obtener la clave de sesión actual
    session_key = request.session.session_key

    # Verificar si ya existe un usuario con la sesión actual
    configUsuario = Usuario.objects.filter(sesion_id=session_key).first()
    if not configUsuario:
        configUsuario = Usuario.objects.create(
            userName='Anónimo',
            sesion_id=session_key,
            sizeSelect='medium',
            fontSelect='Arial'
        )

    comentarios = Comentario.objects.all().order_by('-fecha')

    paginator = Paginator(comentarios, 5)
    page_number = request.GET.get('page')
    page_obj = paginator.get_page(page_number)

    numero_camaras, numero_comentarios = contador()

    context = {
        'comentarios': page_obj,
        'numero_camaras': numero_camaras,
        'numero_comentarios': numero_comentarios,
        'page_obj': page_obj,
        'configUsuario' : configUsuario,
    }
    return render(request, 'AppTeveo/pagina_principal.html', context)


def camaras(request):

    session_key = request.session.session_key
    configUsuario = Usuario.objects.filter(sesion_id=session_key).first()
    if not configUsuario:
        configUsuario = configUsuario(userName='Anónimo')

    camaras = Camara.objects.annotate(num_comentarios=Count('comentario')).order_by('-num_comentarios')
    #obtiene todas las cámaras de la base de datos, junto con el número de comentarios asociados y los ordena

    if not camaras:  # Si no hay cámaras disponibles
        return render(request, 'AppTeveo/pagina_camaras.html')
    
    # elegir aleatoriamente una cámara para mostrar como cámara aleatoria en la página
    random_cam = random.choice(camaras).url

    numero_camaras, numero_comentarios = contador()

    context = {
        'camaras': camaras,
        'random_cam': random_cam,
        'numero_camaras': numero_camaras,
        'numero_comentarios': numero_comentarios,
        'configUsuario' : configUsuario,
    }
    return render(request, 'AppTeveo/pagina_camaras.html', context)


def camara(request, id):

    session_key = request.session.session_key
    configUsuario = Usuario.objects.filter(sesion_id=session_key).first()
    if not configUsuario:
        configUsuario = configUsuario(userName='Anónimo')

    es_dinamica = id.endswith("-dyn")
    id_camara = id[:-4] if es_dinamica else id
    
    camara = get_object_or_404(Camara, id=id_camara)
    comentarios = Comentario.objects.filter(camara=camara).order_by("-fecha")
    
    # Obtener otros datos necesarios para el contexto
    numero_camaras, numero_comentarios = contador()

    # Obtener el número de likes de la cámara actual
    num_likes = Like.objects.filter(Camara=camara).count()

    if request.method == 'POST':
            if Usuario.userName == "Anónimo":
                return redirect('camara', id=id)  # Otra acción que desees tomar si el usuario es anónimo
            # Manejar la solicitud POST para registrar un "like" si no existe ya una combinación de cámara y usuario
            # Verificar si el usuario ya ha dado like
            if not Like.objects.filter(Camara=camara, Usuario=configUsuario).exists():
                like = Like(Camara=camara, Usuario=configUsuario)
                like.save()
                # Redirigir de nuevo a la página de perfil de la cámara después de registrar el "like"
                return redirect('camara', id=id)

    
    # Actualizar el contexto con el número de likes y otros datos
    context = {
        'numero_camaras': numero_camaras,
        'numero_comentarios': numero_comentarios,
        'camara': camara,
        'comentarios': comentarios,
        'configUsuario' : configUsuario,
        'num_likes' : num_likes,
    }
    
    return render(request, "AppTeveo/pagina_camara.html", context)


def camara_dinamica(request, id):

    session_key = request.session.session_key
    configUsuario = Usuario.objects.filter(sesion_id=session_key).first()
    if not configUsuario:
        configUsuario = configUsuario(userName='Anónimo')

    #obtener camara
    camara = get_object_or_404(Camara, id=id)
    
    #obtener comentarios para la pagina
    comentarios = Comentario.objects.filter(camara=camara).order_by("-fecha")
    numero_camaras, numero_comentarios = contador()

    context = {
        'numero_camaras' : numero_camaras,
        'numero_comentarios' : numero_comentarios,
        'camara': camara,
        'comentarios': comentarios,
        'configUsuario' : configUsuario,
    } 
    return render(request, "AppTeveo/pagina_camara_dinamica.html", context)


def imagen_dinamica(request, id):
    
    camara = get_object_or_404(Camara, id=id)
    url_imagen = camara.url 

    try:
        headers = {
            'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:100.0) Gecko/20100101 Firefox/100.0'
        }
        #diccionario de encabezados se utiliza para proporcionar información adicional sobre la solicitud HTTP
        response = requests.get(url_imagen, headers=headers)
        response.raise_for_status()  

        imagen_base64 = base64.b64encode(response.content).decode('utf-8')
        #Codifica el contenido de la respuesta en formato base64
        contenido_html = f'<img src="data:image/jpeg;base64,{imagen_base64}" style="width: 50%; height: auto;">'
        # Construye una cadena HTML que contiene una etiqueta <img> que muestra la imagen incrustada
        return HttpResponse(contenido_html)
    except Exception as e:
        return HttpResponse("Error al cargar la imagen", status=500)
    

def comentarios_dinamicos(request, id):
    #separado de comentarios para que se puedan actualizar solo los campos y no la pagina entera
    camara = get_object_or_404(Camara, id=id)
    comentarios = Comentario.objects.filter(camara=camara).order_by("-fecha")
    return render(request, 'AppTeveo/comentarios_dinamicos.html', {'comentarios': comentarios})


def configuracion(request):
    session_key = request.session.session_key
    configuracion = Usuario.objects.filter(sesion_id=session_key).first()
    if not configuracion:
        configuracion = Usuario(userName='Anónimo')  # Corrección aquí para crear una nueva instancia

    numero_camaras, numero_comentarios = contador()

    if request.method == 'POST':
        if 'logout' in request.POST:
            if configuracion.userName == "Anónimo":
                return redirect('/teveo/')
            else:
                configuracion.delete()
                return redirect('/teveo/')

        # Actualizar manualmente los campos sin usar UsersetupForm
        configuracion.userName = request.POST.get('userName', configuracion.userName)
        configuracion.sizeSelect = request.POST.get('sizeSelect', configuracion.sizeSelect)
        configuracion.fontSelect = request.POST.get('fontSelect', configuracion.fontSelect)
        
        configuracion.sesion_id = session_key
        configuracion.save()

    # Verificar si se ha solicitado un enlace de autorización
        if 'authorize_link' in request.POST:
            # Generar un identificador único para la sesión
            authorize_url = f"{request.build_absolute_uri()}?{session_key}"
            context = {
                'numero_camaras': numero_camaras,
                'numero_comentarios': numero_comentarios,
                'configUsuario': configuracion,
                'authorize_url': authorize_url
            }
            return render(request, 'AppTeveo/pagina_configuracion.html', context)
        else:
            return redirect('/teveo/')

    else:
        # Verificar si se ha proporcionado una URL de sesión
        session_url = request.GET.get('session_url')
        if session_url:
            try:
                # Extraer la ID de sesión de la URL
                session_id = session_url.split('?')[-1]
                # Buscar la configuración con la ID de sesión
                authorized_settings = Usuario.objects.get(sesion_id=session_id)
                # Copiar la configuración a la sesión actual
                configuracion.userName = authorized_settings.userName
                configuracion.sizeSelect = authorized_settings.sizeSelect
                configuracion.fontSelect = authorized_settings.fontSelect
                configuracion.save()
                return redirect('/teveo/')

finalteveo/AppTeveo/templates/AppTeveo/base.html
<!DOCTYPE html>
{% load static %}
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{% block title %}Página Principal{% endblock %}</title>
    <link rel="stylesheet" type="text/css" href="{% static 'css/styles.css' %}">
    <link rel="icon" type="image/png" href="{% static 'favicon.jpg' %}">
    <script src="https://unpkg.com/htmx.org/dist/htmx.min.js"></script>
    <style>
        body {
            font-family: "{{ configUsuario.fontSelect }}", sans-serif;
        }
    </style>
    {% block extra_head %}{% endblock %}
</head>
<body class="{% if configUsuario.sizeSelect %}{{ configUsuario.sizeSelect }}-font{% endif %}">
    <!-- Cabecera -->
    <div class="site-header">
        <a href="/" style="text-decoration: none; color: rgb(253, 249, 249);">TeVeO</a>
    </div>
    <!-- Menú -->
    <header>
        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" href="/teveo/">Principal</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="/teveo/camaras">Cámaras</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="/teveo/configuracion">Configuración</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="/teveo/ayuda">Ayuda</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="/admin/">Admin</a>
                </li>
                <li class="nav-item">
                    <span class="nav-link">Login as: {{ configUsuario.userName }}</span>
                </li>
            </ul>
        </div>
    </header>
    
    <!-- Contenido de la página -->
    <div class="container">
        {% block content %}
            {% if configUsuario %}
                <div class="container mt-5">
                    <div class="row">
                        <div class="col-md-12">
                            <div style="font-family: '{{ configUsuario.fontSelect }}'; font-size: '{{ configUsuario.sizeSelect }}';">
                                {% block inner_content %}
                                    <p>Aquí va tu contenido específico.</p>
                                {% endblock %}
                            </div>
                        </div>
                    </div>
                </div>
            {% else %}
                <p>No se encontró la configuración del usuario.</p>
            {% endif %}
        {% endblock %}
    </div>

    <div style="margin-top: 30px;"></div> <!-- Agrega un div vacío con margen superior de 20px -->
    
    <!-- Pie de página -->
    <footer>
        <div style="font-size: 16px;">
            <span style="color: #f8f6f6;">Cámaras:</span> <b>{{ numero_camaras }}</b>
            <span style="margin-left: 20px; color: #f8f6f6;">Comentarios:</span> <b>{{ numero_comentarios }}</b>
        </div>
    </footer>

    {% block extra_scripts %}{% endblock %}
</body>
</html>

finalteveo/AppTeveo/templates/AppTeveo/comentarios_dinamicos.html
{% if comentarios %}
    <div id="comments-list">
        {% for comentario in comentarios %}
            <div class="comment" style="text-align: center;">
                <h2>Comentario {{ forloop.counter }}</h2>
                <p><strong>Comentario de la Cámara:</strong> <span id="comentario-contenido-{{ comentario.id }}">{{ comentario.contenido }}</span></p>
                <p><strong>Fecha del comentario:</strong> <span id="comentario-fecha-{{ comentario.id }}">{{ comentario.fecha }}</span></p>
            </div>
        {% endfor %}
    </div>
{% else %}
    <h2>No hay comentarios para esta cámara.</h2>
{% endif %}

finalteveo/AppTeveo/templates/AppTeveo/pagina_ayuda.html
{% extends "base.html" %}

{% block title %}Página Ayuda{% endblock %}

{% block content %}
    <div style="text-align: center;">
        <h1>Sergio Cuesta</h1>
        <p>Has acabado en la página de ayuda de Sergio Cuesta, ¿qué necesitas?</p>
        <p>La práctica final de la asignatura consiste en la creación de una aplicación web,
            llamada “TeVeO”, que permitirá comentar lo que se vea en ciertas cámaras.</p>
        <a href="/teveo/" class="button">Volver a la Página Principal</a>
    </div>
{% endblock %}

finalteveo/AppTeveo/templates/AppTeveo/pagina_camara.html
{% extends "base.html" %}

{% block title %}{{ camara.nombre }}{% endblock %}

{% block content %}
    <h1> Página de la Cámara {{ camara.nombre }}</h1>
    
    <div class="camera-info">
        <p><strong>Nombre de la Cámara:</strong> {{ camara.nombre }}</p>
        <p><strong>Lugar de la Cámara:</strong> {{ camara.lugar }}</p>
        <p><strong>Localización:</strong> Latitud: {{ camara.latitud }}, Longitud: {{ camara.longitud }}</p>
    </div>
    
    <div class="camera-image">
        <li class="list-group-item"><img class="comment-image" src="{{ camara.url }}" alt="Imagen de la cámara" style="width: 50%; height: auto;"></li>
        
        <!-- Cuadro de Likes -->
        <div class="like-box">
            <form method="post" style="display: inline;">
                {% csrf_token %}
                <button type="submit" name="like_button">Me gusta</button>
            </form>
            <p>Esta cámara tiene {{ num_likes }} like(s).</p>
        </div>
    </div>
    
    <div class="camera-links">
        <p></p>
        <a href="{% url 'camara_dinamica' camara.id %}" class="card-link">Ver Página Dinámica de la Cámara</a>
        <p></p>
        <a href="{% url 'comentarios' camara.id %}" class="card-link">Escribir un Comentario</a>
        <p></p>
        <a href="{% url 'camara_json' camara.id %}" class="card-link">Ver Información de la Cámara en Json</a>
        <p></p>
    </div>
    
    <div class="camera-comments">
        {% if comentarios %}
            {% for comentario in comentarios %}
                <div class="comment" style="text-align: center;">
                    <h2>Comentario {{ forloop.counter }}</h2>
                    <p><strong>Comentario de la Cámara:</strong> {{ comentario.contenido }}</p>
                    <p><strong>Fecha del comentario:</strong> {{ comentario.fecha }}</p>
                </div>
            {% endfor %}
        {% else %}
            <h2>No hay comentarios para esta cámara.</h2>
        {% endif %}
    </div>
    
{% endblock %}

finalteveo/AppTeveo/templates/AppTeveo/pagina_camara_dinamica.html
{% extends "base.html" %}

{% block title %}{{ camara.nombre }}{% endblock %}

{% block content %}
    <h1> Página de la Cámara Dinámica {{ camara.nombre }}</h1>
    
    <div class="camera-info">
        <p><strong>Nombre de la Cámara:</strong> {{ camara.nombre }}</p>
        <p><strong>Localización:</strong> Latitud: {{ camara.latitud }}, Longitud: {{ camara.longitud }}</p>
    </div>

    <div 
        id="imagen-dinamica" 
        hx-get="{% url 'imagen_dinamica' camara.id %}"
        hx-trigger="load, change, every 30s"
        hx-target="#imagen-dinamica"
        hx-swap="innerHTML"
        hx-poll="30000">
        <img src="{{ camara.url }}" alt="Imagen de la cámara" style="width: 50%; height: auto;">
    </div>
    
    <div class="camera-links">
        <p></p>
        <a href="{% url 'camara' camara.id %}" class="card-link">Ver Página de la Cámara</a>
        <p></p>
        <a href="{% url 'comentarios' camara.id %}" class="card-link">Escribir un Comentario</a>
        <p></p>
        <a href="{% url 'camara_json' camara.id %}" class="card-link">Ver Información de la Cámara en Json</a>
        <p></p>
    </div>
    
    <div id="comments-container" 
        hx-get="{% url 'comentarios_dinamicos' camara.id %}" 
        hx-trigger="load, change, every 30s"
        hx-target="#comments-container"
        hx-swap="innerHTML"
        hx-poll="30000">
        {% include 'AppTeveo/comentarios_dinamicos.html' %}
    </div>
    
{% endblock %}

finalteveo/AppTeveo/templates/AppTeveo/pagina_camaras.html
{% extends "base.html" %}

{% block content %}
<div class="container">
    <!-- Listado de las fuentes de datos disponibles -->
    <div class="mt-3">
        <h2>Listado de Fuentes de Datos Disponibles:</h2>
        <div class="row">
            <div class="col">
                <h3>Listado 1</h3>
                <form action="{% url 'descargar_fuente_datos' listado='listado1' %}" method="post" style="display: inline;">
                    {% csrf_token %}
                    <button type="submit" class="btn btn-primary">Descargar Fuente de Datos 1</button>
                </form>
            </div>
            <div class="col">
                <h3>Listado 2</h3>
                <form action="{% url 'descargar_fuente_datos' listado='listado2' %}" method="post" style="display: inline;">
                    {% csrf_token %}
                    <button type="submit" class="btn btn-primary">Descargar Fuente de Datos 2</button>
                </form>
            </div>
            <div class="col">
                <h3>Listado 3</h3>
                <form action="{% url 'descargar_fuente_datos' listado='listado3' %}" method="post" style="display: inline;">
                    {% csrf_token %}
                    <button type="submit" class="btn btn-primary">Descargar Fuente de Datos 3</button>
                </form>
            </div>
            <div class="col">
                <h3>Listado 4</h3>
                <form action="{% url 'descargar_fuente_datos' listado='listado4' %}" method="post" style="display: inline;">
                    {% csrf_token %}
                    <button type="submit" class="btn btn-primary">Descargar Fuente de Datos 4</button>
                </form>
            </div>
        </div>
    </div>

    <!-- Cámaras disponibles -->
    {% if camaras %}
        <h1 class="text-center mt-5">Cámaras disponibles:</h1>
        <div class="row justify-content-center">
            <div class="col">
                <br>
                <!-- Imagen aleatoria de cámara -->
                <p class="text-center mt-3">Imagen de una camara Aleatoria</p>
                <img src="{{ random_cam }}" alt="Random Camara" class="random-camera-img">
                <br>
            </div>
        </div>
        <div class="mt-3">
            <h2>Listado de Cámaras</h2>
            {% for camara in camaras %}
            <div class="card mb-3">
                <div class="card-body">
                    <p class="card-text">
                        Nombre de la cámara: {{ camara.nombre }}
                        <br>
                        Identificador: {{ camara.id }}
                        <br>
                        Lugar: {{ camara.lugar }}
                        <br>
                        Total Comentarios: {{ camara.comentario_set.count }}
                        <br>
                        Total Likes: {{ camara.like_set.count }}
                    </p>
                    <a href="{% url 'camara' camara.id %}" class="card-link">Página de la Cámara</a>
                    <a href="{% url 'camara_dinamica' camara.id %}" class="card-link">Página Dinámica de la Cámara</a>
                </div>
            </div>
            {% if not forloop.last %}
                <hr> <!-- Línea separadora -->
            {% endif %}
            {% endfor %}
        </div>
    {% else %}
        <h2>No hay cámaras disponibles.</h2>
    {% endif %}
</div>
{% endblock content %}

finalteveo/AppTeveo/templates/AppTeveo/pagina_comentario.html
{% extends "base.html" %}

{% block title %} {{ camara.nombre }} {% endblock %}

{% block content %}
<h1>Página para Poner un Comentario</h1>

<div class="camera-info">
    <p>Nombre de la Cámara: {{ camara.lugar }}</p>
    <p>Localización: Latitud: {{ camara.latitud }}, Longitud: {{ camara.longitud }}</p>
</div>

<div class="camera-image" style="margin-bottom: 20px;">
    <li class="list-group-item"><img class="comment-image" src="{{ camara.url }}" alt="Imagen de la cámara" style="width: 50%; height: auto;"></li>
</div>

<div style="text-align: center; margin-bottom: 50px;"> 
    <form action="" method="POST">
        {% csrf_token %}
        <label for="comment">Escribe tu comentario:</label><br>
        <textarea id="comment" name="comment" rows="4" required></textarea><br>
        <input type="submit" value="Enviar Comentario">
    </form>
</div>

<div style="display: flex; justify-content: center;">
    <div style="text-align: center; background-color: blue; color: white; display: inline-block; padding: 10px; border-radius: 10px; text-align: center;">
        <a href="{{ request.META.HTTP_REFERER }}" style="text-decoration: none; color: white;">Página anterior</a>
    </div>
</div>

<div style="margin-top: 20px;"></div>

{% endblock %}

finalteveo/AppTeveo/templates/AppTeveo/pagina_configuracion.html
{% extends "base.html" %}

{% block title %}Página de Configuración{% endblock %}

{% block content %}
    <div class="container mt-5">
        <h1 class="text-center">Configuración de la página</h1>
        <p class="lead text-center">Personaliza tu experiencia de página aquí.</p>

        <!-- Sección de Registro y Cerrar Sesión -->
        <div class="row justify-content-center">
            <div class="col-sm-7 col-md-7">
                <div class="card mb-3">
                    <div class="card-header">
                        <h2>Registrarse</h2>
                    </div>
                    <div class="card-body">
                        <form action="{% url 'configuracion' %}" method="POST">
                            {% csrf_token %}
                            <div class="mb-3">
                                <label for="userName" class="form-label"><b>Nombre de Usuario:</b></label>
                                <input type="text" id="userName" name="userName" class="form-control" required minlength="3" maxlength="50">
                                <div id="userNameError" class="invalid-feedback">El nombre de usuario debe tener entre 3 y 50 caracteres.</div>
                            </div>
                            <div class="mb-3">
                                <label for="sizeSelect" class="form-label"><b>Tamaño de Letra:</b></label>
                                <select id="sizeSelect" name="sizeSelect" class="form-select">
                                    <option value="small">Pequeña</option>
                                    <option value="medium" selected>Mediana</option>
                                    <option value="large">Grande</option>
                                </select>
                            </div>
                            <div class="mb-3">
                                <label for="fontSelect" class="form-label"><b>Fuente:</b></label>
                                <select id="fontSelect" name="fontSelect" class="form-select">
                                    <option value="Arial">Arial</option>
                                    <option value="Sans-serif">Sans-serif</option>
                                    <option value="Calibri">Calibri</option>
                                    <option value="Times New Roman">Times New Roman</option>
                                </select>
                            </div>
                            <button type="submit" class="btn btn-primary">Registrarse</button>
                            <button type="submit" name="logout" class="btn btn-danger">Cerrar sesión</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>



       <!-- Mostrar enlace de autorización si está disponible -->
        <div class="row justify-content-center mt-3">
            <div class="col-sm-7 col-md-7">
                <form action="{% url 'configuracion' %}" method="POST">
                    {% csrf_token %}
                    <button type="submit" name="authorize_link" class="btn btn-secondary">Obtener enlace de Configuración</button>
                </form>
                {% if authorize_url %}
                <p class="mt-3"><strong>URL de Configuración:</strong> <a href="{{ authorize_url }}">{{ authorize_url }}</a></p>
                {% endif %}
            </div>
        </div>

        <!-- Sección de copiar configuración desde otra sesión -->
        <div class="row justify-content-center mt-3">
            <div class="col-sm-7 col-md-7">
                <h3>Copiar configuración desde otra sesión</h3>
                <form method="get">
                    <div class="mb-3">
                        <label for="session_url" class="form-label">URL de la sesión:</label>
                        <input type="text" id="session_url" name="session_url" class="form-control">
                    </div>
                    <button type="submit" class="btn btn-primary">Copiar configuración</button>
                </form>
            </div>
        </div>

        <!-- Mostrar mensaje de error si hay -->
        {% if error_message %}
        <div class="row justify-content-center mt-3">
            <div class="col-sm-7 col-md-7">
                <div class="alert alert-danger text-center" role="alert">
                    <strong>Error:</strong> {{ error_message }}
                </div>
            </div>
        </div>
        {% endif %}
    </div>
{% endblock %}